#include "descriptor/descriptor.h"


int main(void) {


int i, numframe, nmoneta = 0;
double cadutatotale = 1.4 , incrmoneta = 0.4;
	
/* attributi */
ITEM arancioneaereo;
ITEM biancoaereo;
ITEM vetropiedistalloaereo;

ITEM biancocandela;
ITEM nerostoppino;
ITEM verdesupportocandela;

ITEM nerohamm;
ITEM rosahamm;

ITEM oro;
ITEM argento;
ITEM rame;

ITEM biancopareti;
ITEM grigiopavimento;
ITEM giallinosoffitto;

ITEM biancosedile;
ITEM nerostrutturasedia;

ITEM marronetavolo;
ITEM marronesottotavolo;

ITEM rossotelefono;
ITEM grigiochiarodiscotelefono;
ITEM grigioscuromanopolatelefono;

ITEM violavaso;
ITEM verdegambifiori;
ITEM blufiore1;
ITEM giallofiore2;


/* oggetti */

ITEM aereobianco;
ITEM aereoarancione;
ITEM piedistalloaereo;

ITEM candela;
ITEM stoppino;
ITEM supportocandela;

ITEM hammnero;
ITEM hammrosa;

ITEM monetavert1;
ITEM monetavert2;
ITEM monetavert3;
ITEM monetavert4;
ITEM monetavert5;
ITEM monetavert6;
ITEM monetavert7;
ITEM monetavert8;
ITEM monetavert9;

ITEM pareti;
ITEM pavimento;
ITEM soffitto;

ITEM pilamoneteoro;
ITEM pilamoneteargento;
ITEM pilamoneterame;

ITEM sedile;
ITEM strutturasedia;

ITEM tavolo;
ITEM sottotavolo;

ITEM telefono;
ITEM discotelefono;
ITEM manopolatelefono;

ITEM vaso;
ITEM gambifiori;
ITEM fiore1;
ITEM fiore2;

ITEM mensola;
ITEM coppa;


ITEM scena;




/* luci */

set_background(0.9,0.9,0.9,TRUE);
set_ambient_light(1,1,1,0.9);
create_point_light(-5.062,-0.254,2.571,1,0.8,0.7,0.9,10,"luce_destra");
create_point_light(-2.071,5.018,1.416,1,1,1,1.3,12, "luce_sinistra");
create_point_light(2.475,-1.115,15.21,0.9,0.9,1,3,20, "luce_alta");





/* definizione attributi */



/* arancioneaereo */
arancioneaereo = create_attribute("arancioneaereo");
set_color(arancioneaereo,1,0.4,0,0.2,0.8);
set_reflectivity(arancioneaereo,0.17,15);



/* biancoaereo */
biancoaereo = create_attribute("biancoaereo");
set_color(biancoaereo,1,1,1,0.2,0.8);
set_reflectivity(biancoaereo,0.17,15);



/* vetropiedistalloaereo */
vetropiedistalloaereo = create_attribute("vetropiedistalloaereo");
set_color(vetropiedistalloaereo,0.68,0.86,1,0.5,0.5);
set_reflectivity(vetropiedistalloaereo,0.24,2);
set_transparency(vetropiedistalloaereo,0.87,0.68,1,1.2);



/* biancocandela */
biancocandela = create_attribute("biancocandela");
set_color(biancocandela,1,1,1,0.2,0.8);
set_reflectivity(biancocandela,0,10);



/* nerostoppino */
nerostoppino = create_attribute("nerostoppino");
set_color(nerostoppino,0,0,0,0.1,0.8);
set_reflectivity(nerostoppino,0,20);



/* verdesupportocandela */
verdesupportocandela = create_attribute("verdesupportocandela");
set_color(verdesupportocandela,0,0.75,0,0.1,0.8);
set_reflectivity(verdesupportocandela,0.2,60);



/* nerohamm */
nerohamm = create_attribute("nerohamm");
set_color(nerohamm,0,0,0,0.1,1);
set_reflectivity(nerohamm,0.1,4);



/* rosahamm */
rosahamm = create_attribute("rosahamm");
set_color(rosahamm,1,0.70,0.80,0.1,1);
set_reflectivity(rosahamm,0.02,5);



/* oro */
oro = create_attribute("oro");
set_color(oro,0.75,0.80,0,0.1,0.4);
set_reflectivity(oro,0.45,40);



/* argento */
argento = create_attribute("argento");
set_color(argento,0.75,0.75,0.75,0.1,0.4);
set_reflectivity(argento,0.45,40);



/* rame */
rame = create_attribute("rame");
set_color(rame,0.75,0.25,0,0.1,0.4);
set_reflectivity(rame,0.45,40);



/* biancopareti */
biancopareti = create_attribute("biancopareti");
set_color(biancopareti,0.95,1,0.98,0.3,1);
set_reflectivity(biancopareti,0,10);



/* grigiopavimento */
grigiopavimento = create_attribute("grigiopavimento");
set_color(grigiopavimento,0.60,0.60,0.60,0,0.9);
set_reflectivity(grigiopavimento,0.05,10);



/* giallinosoffitto */
giallinosoffitto = create_attribute("giallinosoffitto");
set_color(giallinosoffitto,0.95,0.95,0.5,0.1,0.9);
set_reflectivity(giallinosoffitto,0,10);



/* biancosedile */
biancosedile = create_attribute("biancosedile");
set_color(biancosedile,0.95,0.95,0.5,0.1,0.8);
set_reflectivity(biancosedile,0,10);



/* nerostrutturasedia */
nerostrutturasedia = create_attribute("nerostrutturasedia");
set_color(nerostrutturasedia,0,0,0,0,1);
set_reflectivity(nerostrutturasedia,0.1,10);



/* marronetavolo */
marronetavolo = create_attribute("marronetavolo");
set_color(marronetavolo,0.40,0.25,0,0.1,1);
set_reflectivity(marronetavolo,0.04,10);



/* marronesottotavolo */
marronesottotavolo = create_attribute("marronesottotavolo");
set_color(marronesottotavolo,0.30,0.20,0,0.1,1);
set_reflectivity(marronesottotavolo,0.03,10);



/* rossotelefono */
rossotelefono = create_attribute("rossotelefono");
set_color(rossotelefono,1,0.1,0,0.1,1);
set_reflectivity(rossotelefono,0.2,15);



/* grigiochiarodiscotelefono */
grigiochiarodiscotelefono = create_attribute("grigiochiarodiscotelefono");
set_color(grigiochiarodiscotelefono,0.75,0.75,0.75,0.1,1);
set_reflectivity(grigiochiarodiscotelefono,0.1,15);



/* grigioscuromanopolatelefono */
grigioscuromanopolatelefono = create_attribute("grigioscuromanopolatelefono");
set_color(grigioscuromanopolatelefono,0.40,0.40,0.40,0.1,1);
set_reflectivity(grigioscuromanopolatelefono,0.1,15);



/* violavaso */
violavaso = create_attribute("violavaso");
set_color(violavaso,0.75,0,0.9,0.1,0.85);
set_reflectivity(violavaso,0.15,15);



/* verdegambifiori */
verdegambifiori = create_attribute("verdegambifiori");
set_color(verdegambifiori,0.15,0.95,0,0.1,0.9);
set_reflectivity(verdegambifiori,0,15);



/* blufiore1 */
blufiore1 = create_attribute("blufiore1");
set_color(blufiore1,0,0,1,0.1,1);
set_reflectivity(blufiore1,0.03,10);



/* giallofiore2 */
giallofiore2 = create_attribute("giallofiore2");
set_color(giallofiore2,1,1,0,0.1,1);
set_reflectivity(giallofiore2,0.03,10);









/* lettura degli obj */

aereobianco = read_obj("aereobianco.obj", "aereobianco");
aereoarancione = read_obj("aereoarancio.obj", "aereoarancione");
piedistalloaereo = read_obj("aereopiedistallo.obj", "piedistalloaereo");

candela = read_obj("candela.obj", "candela");
stoppino = read_obj("candelastoppino.obj", "stoppino");
supportocandela = read_obj("candelasupporto.obj", "supportocandela");

hammnero = read_obj("hammnero.obj", "hammnero");
hammrosa = read_obj("hammrosa.obj", "hammrosa");

monetavert1 = read_obj("monetaverticale3.obj", "monetavert1");
monetavert2 = create_copy(monetavert1, "monetavert2");
monetavert3 = create_copy(monetavert1, "monetavert3");
monetavert4 = create_copy(monetavert1, "monetavert4");
monetavert5 = create_copy(monetavert1, "monetavert5");
monetavert6 = create_copy(monetavert1, "monetavert6");
monetavert7 = create_copy(monetavert1, "monetavert7");
monetavert8 = create_copy(monetavert1, "monetavert8");
monetavert9 = create_copy(monetavert1, "monetavert9");
		

nmoneta = 0;

set_translate(monetavert1,0,0,cadutatotale+(incrmoneta*(nmoneta++)));
set_translate(monetavert2,0,0,cadutatotale+(incrmoneta*(nmoneta++)));
set_translate(monetavert3,0,0,cadutatotale+(incrmoneta*(nmoneta++)));
set_translate(monetavert4,0,0,cadutatotale+(incrmoneta*(nmoneta++)));
set_translate(monetavert5,0,0,cadutatotale+(incrmoneta*(nmoneta++)));
set_translate(monetavert6,0,0,cadutatotale+(incrmoneta*(nmoneta++)));
set_translate(monetavert7,0,0,cadutatotale+(incrmoneta*(nmoneta++)));
set_translate(monetavert8,0,0,cadutatotale+(incrmoneta*(nmoneta++)));
set_translate(monetavert9,0,0,cadutatotale+(incrmoneta*(nmoneta++)));


pareti = read_obj("pareti.obj", "pareti");
pavimento = read_obj("stanzapavimento.obj", "pavimento");
soffitto = read_obj("stanzasoffitto.obj", "soffitto");

pilamoneteoro = read_obj("pilamoneteoro.obj", "pilamoneteoro");
pilamoneteargento = read_obj("pilamoneteargento.obj", "pilamoneteargento");
pilamoneterame = read_obj("pilamoneterame.obj", "pilamoneterame");

sedile = read_obj("sediasedile.obj", "sedile");
strutturasedia = read_obj("sediastruttura.obj", "strutturasedia");

tavolo = read_obj("tavoloripiano.obj", "tavolo");
sottotavolo = read_obj("tavolosotto.obj", "sottotavolo");

telefono = read_obj("telefonocorpo.obj", "telefono");
discotelefono = read_obj("telefonodisco.obj", "discotelefono");
manopolatelefono = read_obj("telefonomanopola.obj", "manopolatelefono");

vaso = read_obj("vaso.obj", "vaso");
gambifiori = read_obj("vasogambifiori.obj", "gambifiori");
fiore1 = read_obj("vasofiore1.obj", "fiore1");
fiore2 = read_obj("vasofiore2.obj", "fiore2");

coppa = read_obj("coppa.obj", "coppa");





/* assegnamento attributi */

set_attribute(aereobianco,biancoaereo);
set_attribute(aereoarancione,arancioneaereo);
set_attribute(piedistalloaereo,vetropiedistalloaereo);

set_attribute(candela,biancocandela);
set_attribute(stoppino,nerostoppino);
set_attribute(supportocandela,verdesupportocandela);

set_attribute(hammnero,nerohamm);
set_attribute(hammrosa,rosahamm);


set_attribute(monetavert1,argento);
set_attribute(monetavert2,argento);
set_attribute(monetavert3,rame);
set_attribute(monetavert4,argento);
set_attribute(monetavert5,oro);
set_attribute(monetavert6,argento);
set_attribute(monetavert7,rame);
set_attribute(monetavert8,oro);
set_attribute(monetavert9,oro);

set_attribute(pareti,biancopareti);
set_attribute(pavimento,grigiopavimento);
set_attribute(soffitto,vetropiedistalloaereo);
/* set_attribute(soffitto,giallinosoffitto); */

set_attribute(pilamoneteoro,oro);
set_attribute(pilamoneteargento,argento);
set_attribute(pilamoneterame,rame);

set_attribute(sedile,biancosedile);
set_attribute(strutturasedia,nerostrutturasedia);

set_attribute(tavolo,marronetavolo);
set_attribute(sottotavolo,marronesottotavolo);

set_attribute(telefono,rossotelefono);
set_attribute(discotelefono,grigiochiarodiscotelefono);
set_attribute(manopolatelefono,grigioscuromanopolatelefono);

set_attribute(vaso,violavaso);
set_attribute(gambifiori,verdegambifiori);
set_attribute(fiore1,blufiore1);
set_attribute(fiore2,giallofiore2);

set_attribute(coppa,oro);


mensola = create_copy(tavolo, "mensola");
set_translate(mensola,3,-3,0.5);

set_attribute(mensola,marronesottotavolo);




/* definizione animazione */

numframe = 99;

for(i=0;i<numframe;i++)
{

/* gravita` */
double poscaduta;

poscaduta = -0.001*i;

cadutatotale += poscaduta;

nmoneta = 0;


if(cadutatotale > -(incrmoneta*(nmoneta++))) set_translate(monetavert1,0,0,poscaduta);
else set_translate(monetavert1,0,0,10);

if(cadutatotale > -(incrmoneta*(nmoneta++))) set_translate(monetavert2,0,0,poscaduta);
else set_translate(monetavert2,0,0,10);

if(cadutatotale > -(incrmoneta*(nmoneta++))) set_translate(monetavert3,0,0,poscaduta);
else set_translate(monetavert3,0,0,10);

if(cadutatotale > -(incrmoneta*(nmoneta++))) set_translate(monetavert4,0,0,poscaduta);
else set_translate(monetavert4,0,0,10);

if(cadutatotale > -(incrmoneta*(nmoneta++))) set_translate(monetavert5,0,0,poscaduta);
else set_translate(monetavert5,0,0,10);

if(cadutatotale > -(incrmoneta*(nmoneta++))) set_translate(monetavert6,0,0,poscaduta);
else set_translate(monetavert6,0,0,10);

if(cadutatotale > -(incrmoneta*(nmoneta++))) set_translate(monetavert7,0,0,poscaduta);
else set_translate(monetavert7,0,0,10);

if(cadutatotale > -(incrmoneta*(nmoneta++))) set_translate(monetavert8,0,0,poscaduta);
else set_translate(monetavert8,0,0,10);

if(cadutatotale > -(incrmoneta*(nmoneta++))) set_translate(monetavert9,0,0,poscaduta);
else set_translate(monetavert9,0,0,10);


/* creazione della scena */

scena = create_list(aereobianco, "scena");

scena = insert_in_list(scena, aereoarancione);
scena = insert_in_list(scena, piedistalloaereo);

scena = insert_in_list(scena, candela);
scena = insert_in_list(scena, stoppino);
scena = insert_in_list(scena, supportocandela);

scena = insert_in_list(scena, hammnero);
scena = insert_in_list(scena, hammrosa);


scena = insert_in_list(scena, monetavert1);
scena = insert_in_list(scena, monetavert2);
scena = insert_in_list(scena, monetavert3);
scena = insert_in_list(scena, monetavert4);
scena = insert_in_list(scena, monetavert5);
scena = insert_in_list(scena, monetavert6);
scena = insert_in_list(scena, monetavert7);
scena = insert_in_list(scena, monetavert8);
scena = insert_in_list(scena, monetavert9);

scena = insert_in_list(scena, pareti);
scena = insert_in_list(scena, pavimento);
/*scena = insert_in_list(scena, soffitto);*/

scena = insert_in_list(scena, pilamoneteoro);
scena = insert_in_list(scena, pilamoneteargento);
scena = insert_in_list(scena, pilamoneterame);

scena = insert_in_list(scena, sedile);
scena = insert_in_list(scena, strutturasedia);

scena = insert_in_list(scena, tavolo);
scena = insert_in_list(scena, sottotavolo);

scena = insert_in_list(scena, telefono);
scena = insert_in_list(scena, discotelefono);
scena = insert_in_list(scena, manopolatelefono);

scena = insert_in_list(scena, vaso);
scena = insert_in_list(scena, gambifiori);
scena = insert_in_list(scena, fiore1);
scena = insert_in_list(scena, fiore2);

scena = insert_in_list(scena, mensola);
scena = insert_in_list(scena, coppa);


save_scene_ani(numframe,"hamm.ani","hamm","scena_hamm",scena);


}

return(0);
}
